ChatAppAsp/Controllers/AuthController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Application.Commands.User;
using Application.Dto.User;
using ChatAppAsp.Hubs;
using DataAccess;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;

namespace ChatAppAsp.Controllers
{
    public class AuthController : Controller
    {
        private readonly UserManager<User> _userManager;
        private readonly SignInManager<User> _signInManager;
        private readonly ISetUserStatusCommand _setUserStatus;
        private readonly IGetUserByUsernameCommand _getUserByUsername;
        private readonly ChatHub _chatHub;

        public AuthController(UserManager<User> userManager, 
            SignInManager<User> signInManager, ISetUserStatusCommand setUserStatus,
            ChatHub chatHub, IGetUserByUsernameCommand getUserByUsernameCommand)
        {
            _userManager = userManager;
            _signInManager = signInManager;
            _setUserStatus = setUserStatus;
            _chatHub = chatHub;
            _getUserByUsername = getUserByUsernameCommand;
        }

        public IActionResult LoginPage()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Login(UserDto user)
        {
            try
            {
                var result = await _signInManager.PasswordSignInAsync(user.Username, user.Password, false, false);
                if (result.Succeeded)
                {
                    await _setUserStatus.Execute(user.Username, true);
                    var profileUpdate = await _getUserByUsername.Execute(user.Username);
                    await _chatHub.SendProfile(profileUpdate);
                    return RedirectToAction("Index", "Home");
                }
                  
                TempData["msg"] = user.Username + " doesn't exist";
                return RedirectToAction("LoginPage");
            }
            catch (Exception e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("LoginPage");
            }
        }

        public IActionResult RegisterPage()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Register(UserDto user)
        {
            try
            {
                User registerUser = await _userManager.FindByNameAsync(user.Username);
                if(registerUser != null)
                {
                    TempData["msg"] = "Username " + user.Username + " already exist!";
                    return RedirectToAction("RegisterPage");
                }
                else
                {
                    registerUser = new User();
                    registerUser.UserName = user.Username;
                    IdentityResult result = await _userManager.CreateAsync(registerUser, user.Password);
                    if (result.Succeeded)
                    {
                        var resultLogin = await _signInManager.PasswordSignInAsync(user.Username, user.Password, false, false);
                        if (resultLogin.Succeeded)
                        {
                            await _setUserStatus.Execute(user.Username, true);
                            var profileUpdate = await _getUserByUsername.Execute(user.Username);
                            await _chatHub.SendProfile(profileUpdate);
                            return RedirectToAction("Index", "Home");
                        }
             
                        TempData["msg"] = result.ToString();
                        return RedirectToAction("LoginPage");
                    }
                    else
                    {
                        TempData["msg"] = result.ToString();
                        return RedirectToAction("RegisterPage");
                    }
                }
            }
            catch (Exception e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("RegisterPage");
            }
        }

        public async Task<IActionResult> Logout(string username)
        {
            await _signInManager.SignOutAsync();
            await _setUserStatus.Execute(username, false);
            var profileUpdate = await _getUserByUsername.Execute(username);
            await _chatHub.SendProfile(profileUpdate);
            return RedirectToAction("Index", "Home");
        }
    }
}

ChatAppAsp/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using ChatAppAsp.Models;
using Application.Dto.User;
using Application.Exceptions;
using Newtonsoft.Json;
using System.Net.Http;
using Application.Commands.User;
using Application.Queries.User;
using Microsoft.AspNetCore.Identity;
using DataAccess;
using Application.Commands.Message;
using Application.Queries.Message;
using Application.Dto.Message;
using Application.Helpers;
using ChatAppAsp.Hubs;

namespace ChatAppAsp.Controllers
{
    public class HomeController : Controller
    {
        private readonly UserManager<User> _userManager;
        private readonly SignInManager<User> _signInManager;
        private readonly IGetUsersCommand _getUsers;
        private readonly UserModel _userModel;
        private readonly IGetMessagesCommand _getMessages;
        private readonly ICreateMessageCommand _createMessage;
        private readonly IGetOneUserCommand _getOneUser;
        private readonly IEditUserCommand _editUser;
        private readonly ImageUpload _imageUpload;
        private readonly ChatHub _chatHub;
        private readonly IGetUserByUsernameCommand _getUserByUsername;

        public HomeController(UserManager<User> userManager,
            IGetUsersCommand getUsers, UserModel userModel,
            IGetMessagesCommand getMessages, ICreateMessageCommand createMessage,
            IGetOneUserCommand getOneUserCommand, IEditUserCommand editUserCommand,
            ImageUpload imageUpload, ChatHub chatHub, IGetUserByUsernameCommand getUserByUsernameCommand,
            SignInManager<User> signInManager)
        {
            _userManager = userManager;
            _getUsers = getUsers;
            _userModel = userModel;
            _getMessages = getMessages;
            _createMessage = createMessage;
            _getOneUser = getOneUserCommand;
            _editUser = editUserCommand;
            _imageUpload = imageUpload;
            _chatHub = chatHub;
            _getUserByUsername = getUserByUsernameCommand;
            _signInManager = signInManager;
        }

        public async Task<ActionResult> Index([FromQuery] UserQuery userQuery, MessageQuery messageQuery)
        {
            _userModel.Users = await _getUsers.Execute(userQuery);
            _userModel.Messages = await _getMessages.Execute(messageQuery);
            return View(_userModel);
        }

        public async Task<IActionResult> Create(MessageCreate messageCreate)
        {
            var user = await _userManager.GetUserAsync(User);
            messageCreate.UserID = user.Id;
            await _createMessage.Execute(messageCreate);
            return Ok();
        }

        public async Task<IActionResult> Edit()
        {
            try
            {
                var user = await _userManager.GetUserAsync(User);
                var userData = await _getOneUser.Execute(user.Id);
                return View(userData);
            }
            catch (EntityNotFoundException e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Index");
            }
            catch (Exception e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit([FromForm] UserEdit userEdit)
        {
            try
            {
                await _signInManager.SignOutAsync();
                var user = await _userManager.GetUserAsync(User);
                userEdit.Id = user.Id;
                userEdit.ImagePath = await _imageUpload.uploadImage(userEdit.Image);
                await _editUser.Execute(userEdit);
                TempData["msg"] = "Succesfully edited user";
                var editedUser = await _getOneUser.Execute(user.Id);
                var profileUpdate = await _getUserByUsername.Execute(editedUser.Username);
                await _chatHub.SendProfile(profileUpdate);
                var userJedi = await _userManager.FindByNameAsync(profileUpdate.Username);
                await _signInManager.SignInAsync(userJedi, false);
                return RedirectToAction("Index");
            }
            catch (EntityAlreadyExistException e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Edit");
            }
            catch (ImageExtensionNotAllowedException e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Edit");
            }
            catch (ImageFileSizeNotAllowedException e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Edit");
            }
            catch (Exception e)
            {
                TempData["msg"] = e.Message;
                return RedirectToAction("Index");
            }

        }
    }
}

ChatAppAsp/Views/Home/Edit.cshtml
@model Application.Dto.User.UserEdit

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>UserEdit</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Username" class="control-label"></label>
                <input asp-for="Username" class="form-control" />
                <span asp-validation-for="Username" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="FirstName" class="control-label"></label>
                <input asp-for="FirstName" class="form-control" />
                <span asp-validation-for="FirstName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="LastName" class="control-label"></label>
                <input asp-for="LastName" class="form-control" />
                <span asp-validation-for="LastName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="City" class="control-label"></label>
                <input asp-for="City" class="form-control" />
                <span asp-validation-for="City" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Image"></label>
                <input asp-for="Image" class="form-control" type="file"/>
                <span asp-validation-for="Image" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

ChatAppAsp/Views/Home/Index.cshtml
@model UserModel;
@{
    ViewData["Title"] = "Home Page";
    var currentUserImage = "NULL";
    if (User.Identity.IsAuthenticated)
    {
        currentUserImage = Model.Users.Where(u => u.Username.ToLower() == User.Identity.Name.ToLower()).First().ImagePath;
    }
}

<body>
    <div class="container-fluid h-100">
        <div class="row justify-content-center h-100">
            <div class="col-md-4 col-xl-3 chat">
                <div class="card mb-sm-3 mb-md-0 contacts_card">
                    <div class="card-header">
                        <div class="input-group">
                            <input type="text" placeholder="Search..." name="" class="form-control search">
                            <div class="input-group-prepend">
                                <span class="input-group-text search_btn"><i class="fas fa-search"></i></span>
                            </div>
                        </div>
                    </div>
                    <div class="card-body contacts_body">
                        <ui class="contacts" id="contacts">
                            @foreach (var user in Model.Users)
                            {
                                <li id="@user.UserID">
                                    <div class="d-flex bd-highlight">
                                        <div class="img_cont">
                                            @if (user.ImagePath != null)
                                            {
                                                <img src="~/uploads/@user.ImagePath" class="rounded-circle user_img">
                                            }
                                            else
                                            {
                                                <img src="https://static.turbosquid.com/Preview/001292/481/WV/_D.jpg" class="rounded-circle user_img">
                                            }

                                            @if (user.IsLogged)
                                            {
                                                <span class="online_icon"></span>
                                            }
                                            else
                                            {
                                                <span class="online_icon offline"></span>
                                            }
                                        </div>
                                        <div class="user_info">
                                            <span>@user.Username</span>
                                            @if (user.LogoutTime != null)
                                            {
                                                <p>Last active at @user.LogoutTime.Value.ToString("dd/MM HH:mm") </p>
                                            }
                                        </div>
                                    </div>
                                </li>
                            }
                        </ui>
                    </div>
                    <div class="card-footer">
                    </div>
                </div>
            </div>
            <div class="col-md-8 col-xl-6 chat">
                <div class="card">
                    <div class="card-body msg_card_body" id="chat">
                        @foreach (var message in Model.Messages)
                        {
                            <div class="d-flex justify-content-start mb-4">
                                <div class="img_cont_msg">
                                    @if (message.ImagePath != null)
                                    {
                                        <img src="~/uploads/@message.ImagePath" class="rounded-circle user_img_msg">
                                    }
                                    else
                                    {
                                        <img src="https://static.turbosquid.com/Preview/001292/481/WV/_D.jpg" class="rounded-circle user_img_msg">
                                    }
                                </div>
                                <div class="msg_cotainer_username">
                                    @message.Username
                                </div>
                                <div class="msg_cotainer">
                                    @message.Text
                                    <span class="msg_time">@message.CreatedAt.Day/@message.CreatedAt.Month @message.CreatedAt.Hour:@message.CreatedAt.Minute</span>
                                </div>
                            </div>
                        }
                    </div>
                    <div class="card-footer">
                        <form asp-action="Create"
                              data-ajax-begin="clearInputField"
                              data-ajax-complete=""
                              data-ajax-failure="alert('Fail')"
                              data-ajax-success="sendMessage"
                              data-ajax="true"
                              data-ajax-method="POST">

                            <div class="input-group">
                                <input type="text" class="form-control type_msg" placeholder="Type your message..." id="messageText" name="Text" />
                                <div class="input-group-append">
                                    @if (User.Identity.IsAuthenticated)
                                    {
                                        <input type="submit" value="Send" id="submitButton" class="btn btn-primary" />
                                    }
                                    else
                                    {
                                        <a class="btn btn-primary" asp-controller="Auth" asp-action="LoginPage">Send</a>
                                    }
                                </div>
                                <input type="hidden" value="@User.Identity.Name" name="Username" id="Username" />
                                <input type="hidden" id="createdAt" />
                                <input type="hidden" value="@currentUserImage" id="ImagePath" />
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
@section Scripts {
    <script type="text/javascript" src="~/js/chat.js"></script>
}